/*
 * rand_config.c
 */

#include <stdio.h>

#define PS(x_lower, x_upper) \
    printf("#define SIZEOF_" #x_upper "\t%i\n", sizeof(x_lower));

int main()
{
    union
    {
	unsigned char	b[8];
	unsigned int	i;
    } endian_test;

    int		i;
    int		rc = 0;
    char	c = 0xff;

    /* print file header */
    printf("\n");
    printf("/*\n");
    printf(" * random_cfg.h\n");
    printf(" * \n");
    printf(" * generated by rand_config\n");
    printf(" */\n\n");
    
    /* print sizes of all types */    
    PS(char, CHAR);
    PS(short, SHORT);
    PS(int, INT);
    PS(float, FLOAT);
    PS(double, DOUBLE);
    printf("\n");

    if (sizeof(int) == 4)
	printf("#define INT32_T\tint\n");
    else
	if (sizeof(short) == 4)
	    printf("#define INT32_T\tshort\n");
	else
	    printf("#undef INT32_T\t/* No such thing /*\n");

    /* figure endian format */
    for (i = 0; i < 8; i++)
	endian_test[i] = 0;
    endian_test[0] = 1;
    
    if (endian_test.i == 1)
	printf("#define RAND_LE\t/* endian = LE */\n\n");
    else
	    printf("#undef RAND_LE\t/* endian = BE */\n\n");

    /* check for 64bit longs */
    if (sizeof(long) < 8)
    {
	printf("/* 64 bit longs are not supported by this machine */\n\n");
    }
    else
	if (sizeof(long) == 8)
	{
	    printf("/*\t64 bit longs are supported by this machine\t*/\n");
	    printf("#define RAND_64\n\n");
	    printf("/*\tuncomment to generate longs > 32 bits\t*/\n");
	    printf("/* #define ALLOW_64BIT_LONG */\n\n");
	}

    /* warning about default char */
    printf("/*\tuncomment to allow 8 bit chars\t*/\n");
    printf("/*\tANSI C says default char attribute\t*/\n");
    printf("/*\tis machine dependent, so the 8th\t/*\n");
    printf("/*\tbit may have unexpected results.\t/*\n");
    printf("/* #define ALLOW_8BIT_CHAR */\n\n");
    
    return(rc);
}
