
AC_DEFUN(LAC_GRAM_ARGS,
[

AC_ARG_WITH(gramjm,
	[  --with-gramjm                 GRAM job manager: condor, easymcs, lsf, or fork [fork]],
	[gram_jm_type="$withval"],
	[gram_jm_type="fork"])

])

AC_DEFUN(LAC_GRAM_TARGET,
[
    LAC_GRAM_ARGS
])

AC_DEFUN(LAC_GRAM_SERVICE,
[
    LAC_GRAM_ARGS

    case "$gram_jm_type" in
        condor )
            GRAMI_JM_TYPE=grami_jm_shell
            GRAMI_JM_SHELL_TYPE=condor
            GRAMI_JM_SHELL_DEFINE=-DGRAMI_CONDOR_MANAGER
        ;;
        easymcs )
            GRAMI_JM_TYPE=grami_jm_shell
            GRAMI_JM_SHELL_TYPE=easymcs
            GRAMI_JM_SHELL_DEFINE=-DGRAMI_EASYMCS_MANAGER
        ;;
        fork )
            GRAMI_JM_TYPE=grami_jm_simple_fork
            GRAMI_JM_SHELL_TYPE=none
            GRAMI_JM_SHELL_DEFINE=
        ;;
        lsf )
            GRAMI_JM_TYPE=grami_jm_lsf
            GRAMI_JM_SHELL_TYPE=lsf
            GRAMI_JM_SHELL_DEFINE=
        ;;
        fake )
            GRAMI_JM_TYPE=grami_jm_fake
            GRAMI_JM_SHELL_TYPE=none
            GRAMI_JM_SHELL_DEFINE=
        ;;
        * )
            AC_MSG_ERROR([Invalid --with-gramjm value: $gramjm_type])
        ;;
    esac

    AC_SUBST(GRAMI_JM_TYPE)
    AC_SUBST(GRAMI_JM_SHELL_TYPE)
    AC_SUBST(GRAMI_JM_SHELL_DEFINE)

])


