
dnl -----------------------------------------------------------------
dnl -- Start of a MDS specific configuration file
dnl --
dnl -- Copied from the Nexus configuration file (acnexus.m4)
dnl -- Many left-overs may be present
dnl --
dnl -----------------------------------------------------------------



AC_DEFUN(LAC_MDS_ARGS,
[


dnl ROOT MDS configuration

AC_CACHE_CHECK(MDS Root Host, mds_cv_root_host, [dnl
    mds_cv_root_host="www.globus.org"
])

AC_CACHE_CHECK(MDS Root Port, mds_cv_root_port, [dnl
    mds_cv_root_port="389"
])

AC_CACHE_CHECK(MDS Root DN, mds_cv_root_dn, [dnl
    mds_cv_root_dn="o=Globus, c=US"
])

AC_CACHE_CHECK(MDS Root Admin DN, mds_cv_root_admin_dn, [dnl
    mds_cv_root_admin_dn="cn=Directory Manager, $mds_cv_root_dn"
])




dnl LOCAL MDS configuration

AC_CACHE_CHECK(MDS Host, mds_cv_local_host, [dnl
AC_ARG_WITH(mds-host,
	[  --with-mds-host=value           Name of the local MDS host],
	[mds_cv_local_host="$withval"],
	[mds_cv_local_host="Not Configured"])
])


AC_CACHE_CHECK(MDS Port, mds_cv_local_port, [dnl
AC_ARG_WITH(mds-port,
	[  --with-mds-port=value           Port number for the local MDS host],
	[mds_cv_local_port="$withval"],
	[mds_cv_local_port="$mds_cv_root_port"])
])


AC_CACHE_CHECK(MDS Local Base DN, mds_cv_local_base_dn, [dnl
AC_ARG_WITH(mds-base-dn,
	[  --with-mds-base-dn=value        DN of the local site],
	[mds_cv_local_base_dn="$withval"],
	[mds_cv_local_base_dn="Not Configured"])
])



AC_CACHE_CHECK(MDS Local Admin DN, mds_cv_local_admin_dn, [dnl
AC_ARG_WITH(mds-admin-dn,
	[  --with-mds-admin-dn=value       DN of the local site's administrator],
	[mds_cv_local_admin_dn="$withval"],
	[mds_cv_local_admin_dn="cn=Directory Manager, $mds_cv_local_base_dn"])
])



dnl END of LAC_MDS_ARGS
])



# We need to clean up this section by pruning out all programs that
# are not used.
AC_DEFUN(LAC_MDS_PROGS,
[

# update the PATH so that system specific programs can be located
USERPATH=$PATH
SYSPATH=/usr/sbin:/usr/etc:/etc
PATH=$PATH:$SYSPATH

AC_PATH_PROGS(SH, sh, true)
AC_PATH_PROG(KSH, ksh, true)

AC_PATH_PROGS(SED, sed, true)
AC_PATH_PROGS(AWK, awk, true)
AC_PATH_PROGS(TR, tr, true)


AC_PATH_PROGS(GREP, grep, true)
AC_PATH_PROGS(FGREP, fgrep, true)
AC_PATH_PROGS(EGREP, egrep, true)

AC_PATH_PROGS(TAIL, tail, true)
AC_PATH_PROGS(HEAD, head, true)

AC_PATH_PROGS(PRINTF, printf, echo)

if test "X$PRINTF" = "Xecho" ; then
  echo
  AC_MSG_WARN("PRINTF is not found");
  echo
fi

echo "#"
echo "# Probing for shell and unix commands"
echo "#"


AC_PATH_PROGS(PERL, perl5 perl, true)
AC_PATH_PROGS(STRINGS, strings, true)
AC_PATH_PROGS(TAIL, tail, true)
AC_PATH_PROGS(HEAD, head, true)
AC_PATH_PROGS(CUT, cut, true)
AC_PATH_PROGS(CAT, cat, true)
AC_PATH_PROGS(TR, tr, true)


AC_PATH_PROGS(NETSTAT, netstat, true)
AC_PATH_PROGS(NSLOOKUP, nslookup, true)

AC_PATH_PROGS(REMSH, remsh rsh, true)
AC_PATH_PROGS(SORT, sort, true)
AC_PATH_PROGS(UNIQ, uniq, true)


AC_PATH_PROGS(DATE, date, true)

AC_PATH_PROGS(HOSTID, hostid, true) 

AC_PATH_PROGS(WHOAMI, whoami, true)

echo "#"
echo "# Probing for hostinformation commands"
echo "#"

AC_PATH_PROGS(uptime, uptime, true)
AC_PATH_PROGS(dmesg, dmesg, true)
AC_PATH_PROGS(gfxinfo, gfxinfo, true)
AC_PATH_PROGS(fs, fs, true)
AC_PATH_PROGS(lsdev, lsdev, true)
AC_PATH_PROGS(uname, uname, true)
AC_PATH_PROGS(basename, basename, true)
AC_PATH_PROGS(domainname, domainname, true)
AC_PATH_PROGS(whoami, whoami, true)
AC_PATH_PROGS(hinv, hinv, true)
AC_PATH_PROGS(df, df, true)


echo "#"
echo "# Probing for Network commands"
echo "#"

AC_PATH_PROGS(PING, ping, true)
AC_PATH_PROGS(ping, ping, true)
AC_PATH_PROGS(hostname, hostname, true)
AC_PATH_PROGS(hostid, hostid, true)
AC_PATH_PROGS(ifconfig, ifconfig, true)
AC_PATH_PROGS(nslookup, nslookup, true)
AC_PATH_PROGS(netstat, netstat, true)
AC_PATH_PROGS(ypcat, ypcat, true)
AC_PATH_PROGS(ypmatch, ypmatch, true)

AC_PATH_PROGS(pstat, pstat, true)
AC_PATH_PROGS(finger, finger, true)
AC_PATH_PROGS(sysinfo, sysinfo, true)


dnl Do we need the following
dnl (They are currently referenced in mds-build/whatami)
AC_PATH_PROGS(rpcinfo, rpcinfo)


AC_PATH_PROGS(ECHO, echo)
AC_PATH_PROGS(STTY, stty)
AC_PATH_PROGS(MAKE, make)

#Reset the PATH
PATH=$USERPATH
])


AC_DEFUN(LAC_MDS,
[

LAC_MDS_ARGS
LAC_MDS_PROGS

dnl 
dnl Perl required by just the tools directory
dnl
dnl I don't think Perl 5 is really required.
dnl
dnl
dnl if test "X$PERL" != "X"  ; then
dnl  PERL_VERSION=`$PERL -v | grep version | \
dnl 		$CUT -d" " -f5 | $CUT -d"." -f1`
dnl 
dnl    if  test "$PERL_VERSION" -lt  5 ; then
dnl           AC_MSG_WARN("Perl Version 5 or higher required to run MDS tools")
dnl    fi
dnl else
dnl    AC_MSG_WARN("Perl is not located on this machine")
dnl fi


])
