/*
 * handlers.h
 */

#ifndef HANDLERS_H
#define HANDLERS_H

#include <nexus.h>

/* initialize and cleanup an endpoint to be used in testing */

int InitEndpoint(nexus_endpoint_t *ep, int num_nodes, int verbose);
int DoneEndpoint(nexus_endpoint_t *ep);


/* HANDLER_ID's */

#define RESULT_HANDLER_ID		0
#define CONNECT_HANDLER_ID		1
#define DISCONNECT_HANDLER_ID		2
#define INIT_MSG_HANDLER_ID		3
#define KILL_MSG_HANDLER_ID		4
#define MALLOC_DATA_HANDLER_ID		5
#define FREE_DATA_HANDLER_ID		6
#define CMP_TYPE_HANDLER_ID		7
#define CMP_DATA_HANDLER_ID		8
#define S_SEND_TYPE_HANDLER_ID		9
#define M_RECV_TYPE_HANDLER_ID		10
#define S_RECV_TYPE_HANDLER_ID		11
#define S_SEND_DATA_HANDLER_ID		12
#define M_RECV_DATA_HANDLER_ID		13
#define S_RECV_DATA_HANDLER_ID		14
#define GEN_TYPE_HANDLER_ID		15
#define GEN_DATA_HANDLER_ID		16
#define SHUTDOWN_CONTEXT_HANDLER_ID	17
#define STOP_WAITING_HANDLER_ID		18
#define JOIN_GROUP_HANDLER_ID		19
#define RUN_TEST_HANDLER_ID		20
#define REPORT_HANDLER_ID		21

#endif
