/*
 * dc_chk_macros.h
 */

/*
 * Common variables
 */	
#define DECLARE_CHK_VARS \
	int	i;

/*
 * Unsigned
 */	

#define CHK_U32BE_TO_U16() \
    for (i = 0; i < count; i++) \
    { \
	if (buffer[0] | buffer[1]) \
	    return (i); \
	buffer += 4; \
    }

#define CHK_U64BE_TO_U16() \
    for (i = 0; i < count; i++) \
    { \
	if (buffer[0] | buffer[1] | \
	    buffer[2] | buffer[3] | \
	    buffer[4] | buffer[5]) \
	    return (i); \
        buffer += 8; \
    }

#define CHK_U64BE_TO_U32() \
    for (i = 0; i < count; i++) \
    { \
	if (buffer[0] | buffer[1] | \
	    buffer[2] | buffer[3]) \
	    return (i); \
	buffer += 8; \
    }

#define CHK_U64LE_TO_U32() \
    for (i = 0; i < count; i++) \
    { \
	if (buffer[4] | buffer[5] | \
	    buffer[6] | buffer[7]) \
	    return (i); \
	buffer += 8; \
    }

/*
 * Signed
 *
 */

#define CHK_S16BE_TO_S8() \
    for (i = 0; i < count; i++) \
    { \
	if ((buffer[1] & 0x80) == 0) \
	{ \
	    if (buffer[0] != 0) \
		return (i); \
	} \
	else \
	{ \
	    if (buffer[0] != 0xff) \
		return (i); \
	} \
	buffer += 2; \
    }

#define CHK_S32BE_TO_S16() \
    for (i = 0; i < count; i++) \
    { \
	if ((buffer[3] & 0x80) == 0) \
	{ \
	    if ((buffer[0] | buffer[1]) != 0) \
		return (i); \
	} \
 	else \
	{ \
	    if ((buffer[0] & buffer[1]) != 0xff) \
		return (i); \
	} \
	buffer += 4; \
    }

#define CHK_S64BE_TO_S16() \
    for (i = 0; i < count; i++) \
    { \
	if ((buffer[6] & 0x80) == 0) \
	{ \
	    if ((buffer[0] | buffer[1] | \
		 buffer[2] | buffer[3] | \
		 buffer[4] | buffer[5]) != 0) \
		return (i); \
	} \
	else \
	{ \
	    if ((buffer[0] & buffer[1] & \
		 buffer[2] & buffer[3] & \
		 buffer[4] & buffer[5]) != 0xff) \
		return (i); \
	} \
	buffer += 8; \
    }

#define CHK_S64LE_TO_S32() \
    for (i = 0; i < count; i++) \
    { \
	if ((buffer[3] & 0x80) == 0) \
	{ \
	    if ((buffer[4] | buffer[5] | \
		 buffer[6] | buffer[7]) != 0) \
		return (i); \
	} \
	else \
	{ \
	    if ((buffer[4] & buffer[5] & \
		 buffer[6] & buffer[7]) != 0xff) \
		return (i); \
	} \
	buffer += 8; \
    }

#define CHK_S64BE_TO_S32() \
    for (i = 0; i < count; i++) \
    { \
	if ((buffer[4] & 0x80) == 0) \
	{ \
	    if ((buffer[0] | buffer[1] | \
		 buffer[2] | buffer[3]) != 0) \
		return (i); \
	} \
	else \
	{ \
	    if ((buffer[0] & buffer[1] & \
		 buffer[2] & buffer[3]) != 0xff) \
		return (i); \
	} \
	buffer += 8; \
    }

/*
 * Java to unsigned
 */

/* Simple check of the highest bit to be
 * zero for any conversion does not lose
 * more than 1 bit.
 */
#define CHK_JAVA_S_TO_U(N_BYTES) \
    for (i = 0; i < count; i++) \
    { \
	if ((buffer[0] & 0x80) != 0) \
	    return (i); \
	\
	buffer += N_BYTES; \
    }

#define CHK_S16BE_TO_U8() \
    for (i = 0; i < count; i++) \
    { \
	if ((buffer[0] | (buffer[1] & 0x80)) != 0) \
	    return (i); \
	\
	buffer += 2; \
    }

#define CHK_S64BE_TO_U32() \
    for (i = 0; i < count; i++) \
    { \
	if ((buffer[0] | buffer[1] | \
	     buffer[2] | buffer[3] | \
	     (buffer[4] & 0x80)) != 0) \
	    return (i); \
	\
	buffer += 8; \
    }

/*
 * IEEE to CRAY
 *
 * Check the exponent for all 1's (Inf/NaN).
 */
    
#define CHK_IEEE32LE_TO_CRAY64() \
{ \
    for (i = 0; i < count; i++) \
    { \
	if (((buffer[3] | 0x80) & \
	     (buffer[2] | 0x7f)) == 0xff) \
	   return (i); \
	\
	buffer += 4; \
    } \
}

#define CHK_IEEE32BE_TO_CRAY64() \
{ \
    for (i = 0; i < count; i++) \
    { \
	if (((buffer[0] | 0x80) & \
	     (buffer[1] | 0x7f)) == 0xff) \
	   return (i); \
	\
	buffer += 4; \
    } \
}

#define CHK_IEEE64LE_TO_CRAY64() \
{ \
    for (i = 0; i < count; i++) \
    { \
        if (((buffer[7] | 0x80) & \
	     (buffer[6] | 0x0f)) == 0xff) \
	    return (i); \
	\
	buffer += 8; \
    } \
}

#define CHK_IEEE64BE_TO_CRAY64() \
{ \
    for (i = 0; i < count; i++) \
    { \
        if (((buffer[0] | 0x80) & \
	     (buffer[1] | 0x0f)) == 0xff) \
	    return (i); \
	\
	buffer += 8; \
    } \
}

/*
 * CRAY to IEEE
 *
 * Check exponent for overflow.  Underflow to zero is allowed.
 */

#define CHK_CRAY64BE_TO_IEEE32() \
{ \
    INT32_T	e; \
    \
    for (i = 0; i < count; i++) \
    { \
	e = ((INT32_T)(buffer[0]) << 8) | (INT32_T)buffer[1]; \
	e = (e & 0x7fff) - (CRAY64_BIAS - IEEE32_BIAS); \
	if (e > IEEE32_EXP_MAX) \
	    return (i); \
	\
	buffer += 8; \
    } \
}

#define CHK_CRAY64BE_TO_IEEE64() \
{ \
    INT32_T	e; \
    \
    for (i = 0; i < count; i++) \
    { \
	e = ((INT32_T)(buffer[0]) << 8) | (INT32_T)buffer[1]; \
	e = (e & 0x7fff) - (CRAY64_BIAS - IEEE32_BIAS); \
	if (e > IEEE64_EXP_MAX) \
	    return (i); \
	\
	buffer += 8; \
    } \
}
