/*
 * dc_get_macros.h
 */

/* common variables used by all macros */
#define DECLARE_GET_VARS \
	nexus_byte_t *src = (nexus_byte_t *) *buffer; \
	nexus_byte_t *dst = (nexus_byte_t *) data; \
	int i

/**********************************
 * Source larger than destination *
 *                                *
 * Must know size and endian of   *
 * source, size of destination.   *
 **********************************/

/* #undef GET_16LE_TO_8() -- not needed */
	
#define GET_16BE_TO_8() \
    for (i = 0; i < count; i++) \
    { \
	dst[0] = src[1]; \
	src += 2; \
	dst += 1; \
    } \
    *buffer += count * 2

/* #undef GET_32LE_TO_8() -- not needed */

/* #undef GET_32BE_TO_8() -- not needed */

/* #undef GET_64LE_TO_8() -- not needed */

/* #undef GET_64BE_TO_8() -- not needed */
    
/* #undef GET_32LE_TO_16() -- not needed */
    
#define GET_32BE_TO_16() \
    for (i = 0; i < count; i++) \
    { \
	dst[BYTE_16_1] = src[2]; \
	dst[BYTE_16_0] = src[3]; \
	src += 4; \
	dst += 2; \
    } \
    *buffer += count * 4

/* #undef GET_64LE_TO_16() -- not needed */
    
#define GET_64BE_TO_16() \
    for (i = 0; i < count; i++) \
    { \
	dst[BYTE_16_1] = src[6]; \
	dst[BYTE_16_0] = src[7]; \
	src += 8; \
	dst += 2; \
    } \
    *buffer += count * 8

#define GET_64LE_TO_32() \
    for (i = 0; i < count; i++) \
    { \
	dst[BYTE_32_0] = src[0]; \
	dst[BYTE_32_1] = src[1]; \
	dst[BYTE_32_2] = src[2]; \
	dst[BYTE_32_3] = src[3]; \
	src += 8; \
	dst += 4; \
    } \
    *buffer += count * 8

#define GET_64BE_TO_32() \
    for (i = 0; i < count; i++) \
    { \
	dst[BYTE_32_3] = src[4]; \
	dst[BYTE_32_2] = src[5]; \
	dst[BYTE_32_1] = src[6]; \
	dst[BYTE_32_0] = src[7]; \
	src += 8; \
	dst += 4; \
    } \
    *buffer += count * 8

/****************************************
 * Source and destination are same size *
 *                                      *
 * Must know size of source and         *
 * destination, whether to swap bytes.  *
 ****************************************/
	
#define GET_8_TO_8() \
    memcpy(dst, src, count); \
    *buffer += count;

#define GET_16_TO_16() \
    memcpy(dst, src, count * 2); \
    *buffer += count * 2

#define GET_16_TO_16_SWAP() \
    for (i = 0; i < count; i++) \
    { \
	dst[1] = src[0]; \
	dst[0] = src[1]; \
	src += 2; \
	dst += 2; \
    } \
    *buffer += count * 2

#define GET_32_TO_32() \
    memcpy(dst, src, count * 4); \
    *buffer += count * 4
    
#define GET_32_TO_32_SWAP() \
    for (i = 0; i < count; i++) \
    { \
	dst[3] = src[0]; \
	dst[2] = src[1]; \
	dst[1] = src[2]; \
	dst[0] = src[3]; \
	src += 4; \
	dst += 4; \
    } \
    *buffer += count * 4

#define GET_64_TO_64() \
    memcpy(dst, src, count * 8); \
    *buffer += count * 8
    
#define GET_64_TO_64_SWAP() \
    for (i = 0; i < count; i++) \
    { \
	dst[7] = src[0]; \
	dst[6] = src[1]; \
	dst[5] = src[2]; \
	dst[4] = src[3]; \
	dst[3] = src[4]; \
	dst[2] = src[5]; \
	dst[1] = src[6]; \
	dst[0] = src[7]; \
	src += 8; \
	dst += 8; \
    } \
    *buffer += count * 8

/**********************************************
 * source is zero extended to fit destination *
 *                                            *
 * Must know size and endian of source.       *
 * Destination size is prefixed with "U".     *
 * Soure must be assumed unsigned.            *
 **********************************************/

#define GET_16LE_TO_U32() \
    for (i = 0; i < count; i++) \
    { \
	dst[BYTE_32_0] = src[0]; \
	dst[BYTE_32_1] = src[1]; \
	dst[BYTE_32_2] = 0x00; \
	dst[BYTE_32_3] = 0x00; \
	src += 2; \
	dst += 4; \
    } \
    *buffer += count * 2

#define GET_16BE_TO_U32() \
    for (i = 0; i < count; i++) \
    { \
	dst[BYTE_32_1] = src[0]; \
	dst[BYTE_32_0] = src[1]; \
	dst[BYTE_32_2] = 0x00; \
	dst[BYTE_32_3] = 0x00; \
	src += 2; \
	dst += 4; \
    } \
    *buffer += count * 2

#define GET_16LE_TO_U64() \
    for (i = 0; i < count; i++) \
    { \
	dst[BYTE_64_0] = src[0]; \
	dst[BYTE_64_1] = src[1]; \
	dst[BYTE_64_2] = 0x00; \
	dst[BYTE_64_3] = 0x00; \
	dst[BYTE_64_4] = 0x00; \
	dst[BYTE_64_5] = 0x00; \
	dst[BYTE_64_6] = 0x00; \
	dst[BYTE_64_7] = 0x00; \
	src += 2; \
	dst += 8; \
    } \
    *buffer += count * 2

#define GET_16BE_TO_U64() \
    for (i = 0; i < count; i++) \
    { \
	dst[BYTE_64_1] = src[0]; \
	dst[BYTE_64_0] = src[1]; \
	dst[BYTE_64_2] = 0x00; \
	dst[BYTE_64_3] = 0x00; \
	dst[BYTE_64_4] = 0x00; \
	dst[BYTE_64_5] = 0x00; \
	dst[BYTE_64_6] = 0x00; \
	dst[BYTE_64_7] = 0x00; \
	src += 2; \
	dst += 8; \
    } \
    *buffer += count * 2

#define GET_32LE_TO_U64() \
    for (i = 0; i < count; i++) \
    { \
	dst[BYTE_64_0] = src[0]; \
	dst[BYTE_64_1] = src[1]; \
	dst[BYTE_64_2] = src[2]; \
	dst[BYTE_64_3] = src[3]; \
	dst[BYTE_64_4] = 0x00; \
	dst[BYTE_64_5] = 0x00; \
	dst[BYTE_64_6] = 0x00; \
	dst[BYTE_64_7] = 0x00; \
	src += 4; \
	dst += 8; \
    } \
    *buffer += count * 4

#define GET_32BE_TO_U64() \
    for (i = 0; i < count; i++) \
    { \
	dst[BYTE_64_3] = src[0]; \
	dst[BYTE_64_2] = src[1]; \
	dst[BYTE_64_1] = src[2]; \
	dst[BYTE_64_0] = src[3]; \
	dst[BYTE_64_4] = 0x00; \
	dst[BYTE_64_5] = 0x00; \
	dst[BYTE_64_6] = 0x00; \
	dst[BYTE_64_7] = 0x00; \
	src += 4; \
	dst += 8; \
    } \
    *buffer += count * 4
    
/***********************************************
 * source is sign extended to fit destination  *
 *                                             *
 * Must know size and endian of source, both   *
 * source and destination have "S" prefix.     *
 * If source is unsigned, use Z-extend macros. *
 ***********************************************/

#define GET_S16LE_TO_S32() \
    for (i = 0; i < count; i++) \
    { \
	nexus_byte_t f = FILLVAL(dst[BYTE_32_1] = src[1]); \
	dst[BYTE_32_0] = src[0]; \
	dst[BYTE_32_2] = f; \
	dst[BYTE_32_3] = f; \
	src += 2; \
	dst += 4; \
    } \
    *buffer += count * 2

#define GET_S16BE_TO_S32() \
    for (i = 0; i < count; i++) \
    { \
	nexus_byte_t f = FILLVAL(dst[BYTE_32_1] = src[0]); \
	dst[BYTE_32_0] = src[1]; \
	dst[BYTE_32_2] = f; \
	dst[BYTE_32_3] = f; \
	src += 2; \
	dst += 4; \
    } \
    *buffer += count * 2

#define GET_S16LE_TO_S64() \
    for (i = 0; i < count; i++) \
    { \
	nexus_byte_t f = FILLVAL(dst[BYTE_64_1] = src[1]); \
        dst[BYTE_64_0] = src[0]; \
        dst[BYTE_64_2] = f; \
        dst[BYTE_64_3] = f; \
        dst[BYTE_64_4] = f; \
        dst[BYTE_64_5] = f; \
        dst[BYTE_64_6] = f; \
        dst[BYTE_64_7] = f; \
	src += 2; \
	dst += 8; \
    } \
    *buffer += count * 2

#define GET_S16BE_TO_S64() \
    for (i = 0; i < count; i++) \
    { \
	nexus_byte_t f = FILLVAL(dst[BYTE_64_1] = src[0]); \
	dst[BYTE_64_0] = src[1]; \
	dst[BYTE_64_2] = f; \
	dst[BYTE_64_3] = f; \
	dst[BYTE_64_4] = f; \
	dst[BYTE_64_5] = f; \
	dst[BYTE_64_6] = f; \
	dst[BYTE_64_7] = f; \
	src += 2; \
	dst += 8; \
    } \
    *buffer += count * 2

#define GET_S32LE_TO_S64() \
    for (i = 0; i < count; i++) \
    { \
	nexus_byte_t f = FILLVAL(dst[BYTE_64_3] = src[3]); \
	dst[BYTE_64_0] = src[0]; \
	dst[BYTE_64_1] = src[1]; \
	dst[BYTE_64_2] = src[2]; \
	dst[BYTE_64_4] = f; \
	dst[BYTE_64_5] = f; \
	dst[BYTE_64_6] = f; \
	dst[BYTE_64_7] = f; \
	src += 4; \
	dst += 8; \
    } \
    *buffer += count * 4


#define GET_S32BE_TO_S64() \
    for (i = 0; i < count; i++) \
    { \
	nexus_byte_t f = FILLVAL(dst[BYTE_64_3] = src[0]); \
	dst[BYTE_64_2] = src[1]; \
	dst[BYTE_64_1] = src[2]; \
	dst[BYTE_64_0] = src[3]; \
	dst[BYTE_64_4] = f; \
	dst[BYTE_64_5] = f; \
	dst[BYTE_64_6] = f; \
	dst[BYTE_64_7] = f; \
	src += 4; \
	dst += 8; \
    } \
    *buffer += count * 4
    

/*************************************
 * cray <--> ieee floats and doubles *
 *************************************/

/*
 * Constants default to ints, so (1 << 47)
 * goes out of range.  Should use (1L << 47).
 */

/*
 * IEEE, 32 bits
 * 1 bit sign, 8 bits exponent (bias 127), 23 bits mantissa
 */
#define IEEE32_BIAS		127
#define IEEE32_MAN_MASK		0x007fffff
#define IEEE32_EXP_MASK		0x7f800000
#define IEEE32_EXP_SHIFT	23
#define IEEE32_EXP_DENORMAL	0
#define IEEE32_EXP_MAX		254
#define IEEE32_SIGN_MASK	0x80000000
#define IEEE32_SIGN_SHIFT	31
    
/*
 * IEEE, 64 bits
 * 1 bit sign, 11 bits exponent (bias 1023), 52 bits mantissa
 */    
#define IEEE64_BIAS		1023
#define IEEE64_MAN_MASK		0x000fffffffffffffL
#define IEEE64_MAN_MASK_HI	0x000fffff
#define IEEE64_EXP_MASK		0x7ff0000000000000L
#define IEEE64_EXP_SHIFT	52
#define IEEE64_EXP_DENORMAL	0
#define IEEE64_EXP_MAX		2046
#define IEEE64_SIGN_MASK	0x8000000000000000L
#define IEEE64_SIGN_MASK_HI	0x80000000
#define IEEE64_SIGN_SHIFT	63

/*
 * CRAY, 64 bits
 * 1 bit sign, 15 bits exponent (bias 16385), 1.47 bits mantissa
 */    
#define CRAY64_BIAS		16385
#define CRAY64_MAN_MASK		0x0000ffffffffffffL
#define CRAY64_NORMAL_1		0x0000800000000000L
#define CRAY64_NORMAL_1_HI	0x00008000
#define CRAY64_EXP_MASK		0x7fff000000000000L
#define CRAY64_EXP_MASK_HI	0x7fff0000
#define CRAY64_EXP_SHIFT	48
#define CRAY64_SIGN_MASK	0x8000000000000000L
#define CRAY64_SIGN_MASK_HI	0x80000000
#define CRAY64_SIGN_SHIFT	63

#define GET_IEEE32LE_TO_CRAY64() \
{ \
    unsigned long	e, m, s; \
    union \
    { \
	unsigned long	l; \
	nexus_byte_t	b[8]; \
    } buf; \
    \
    for (i = 0; i < count; i++) \
    { \
	buf.l = 0; \
	buf.b[BYTE_64_0] = src[0]; \
	buf.b[BYTE_64_1] = src[1]; \
	buf.b[BYTE_64_2] = src[2]; \
	buf.b[BYTE_64_3] = src[3]; \
        \
	e = (buf.l & IEEE32_EXP_MASK) >> IEEE32_EXP_SHIFT; \
	m = (buf.l & IEEE32_MAN_MASK); \
	s = (buf.l & IEEE32_SIGN_MASK) << \
		   (CRAY64_SIGN_SHIFT - IEEE32_SIGN_SHIFT); \
	\
	if (e > 0) \
	{ \
	    buf.l = (s | \
		     ((e + CRAY64_BIAS - IEEE32_BIAS) << CRAY64_EXP_SHIFT) | \
		     CRAY64_NORMAL_1 | \
		     (m << (CRAY64_EXP_SHIFT - IEEE32_EXP_SHIFT - 1))); \
	} \
	else \
	{ \
	    if (m && ALLOW_DENORMALS) /* != 0.0 */ \
	    { \
		e = CRAY64_BIAS - IEEE32_BIAS; \
		while ((m & 0x007c0000) == 0) \
		{ \
		    m = m << 5; \
		    e -= 5; \
		} \
		while ((m & 0x00400000) == 0) \
		{ \
		    m = m << 1; \
		    e -= 1; \
		} \
		buf.l = s | \
		      (e << CRAY64_EXP_SHIFT) | \
		      (m << (CRAY64_EXP_SHIFT - IEEE32_EXP_SHIFT)); \
	    } \
	    else \
	    { \
		buf.l = s; \
	    } \
	} \
	\
	dst[0] = buf.b[0]; \
	dst[1] = buf.b[1]; \
	dst[2] = buf.b[2]; \
	dst[3] = buf.b[3]; \
	dst[4] = buf.b[4]; \
	dst[5] = buf.b[5]; \
	dst[6] = buf.b[6]; \
	dst[7] = buf.b[7]; \
	\
	src += 4; \
	dst += 8; \
    } \
    *buffer += count * 4; \
}

#define GET_IEEE32BE_TO_CRAY64() \
{ \
    unsigned long	e, m, s; \
    union \
    { \
	unsigned long	l; \
	nexus_byte_t	b[8]; \
    } buf; \
    \
    for (i = 0; i < count; i++) \
    { \
	buf.l = 0; \
	buf.b[BYTE_64_3] = src[0]; \
	buf.b[BYTE_64_2] = src[1]; \
	buf.b[BYTE_64_1] = src[2]; \
	buf.b[BYTE_64_0] = src[3]; \
        \
	e = (buf.l & IEEE32_EXP_MASK) >> IEEE32_EXP_SHIFT; \
	m = (buf.l & IEEE32_MAN_MASK); \
	s = (buf.l & IEEE32_SIGN_MASK) << \
		   (CRAY64_SIGN_SHIFT - IEEE32_SIGN_SHIFT); \
	\
	if (e > IEEE32_EXP_DENORMAL) \
	{ \
	    buf.l = (s | \
		     ((e + CRAY64_BIAS - IEEE32_BIAS) << CRAY64_EXP_SHIFT) | \
		     CRAY64_NORMAL_1 | \
		     (m << (CRAY64_EXP_SHIFT - IEEE32_EXP_SHIFT - 1))); \
	} \
	else \
	{ \
	    if (m && ALLOW_DENORMALS) /* != 0.0 */ \
	    { \
		e = CRAY64_BIAS - IEEE32_BIAS; \
		while ((m & 0x007c0000) == 0) \
		{ \
		    m = m << 5; \
		    e -= 5; \
		} \
		while ((m & 0x00400000) == 0) \
		{ \
		    m = m << 1; \
		    e -= 1; \
		} \
		buf.l = s | \
		      (e << CRAY64_EXP_SHIFT) | \
		      (m << (CRAY64_EXP_SHIFT - IEEE32_EXP_SHIFT)); \
	    } \
	    else \
	    { \
		buf.l = s; \
	    } \
	} \
	\
	dst[0] = buf.b[0]; \
	dst[1] = buf.b[1]; \
	dst[2] = buf.b[2]; \
	dst[3] = buf.b[3]; \
	dst[4] = buf.b[4]; \
	dst[5] = buf.b[5]; \
	dst[6] = buf.b[6]; \
	dst[7] = buf.b[7]; \
	\
	src += 4; \
	dst += 8; \
    } \
    *buffer += count * 4; \
}

#define GET_IEEE64LE_TO_CRAY64() \
{ \
    unsigned long	s, e, m; \
    \
    union \
    { \
	unsigned long	l; \
	nexus_byte_t	b[8]; \
    } buf; \
    \
    for (i = 0; i < count; i++) \
    { \
	buf.b[BYTE_64_0] = src[0]; \
	buf.b[BYTE_64_1] = src[1]; \
	buf.b[BYTE_64_2] = src[2]; \
	buf.b[BYTE_64_3] = src[3]; \
	buf.b[BYTE_64_4] = src[4]; \
	buf.b[BYTE_64_5] = src[5]; \
	buf.b[BYTE_64_6] = src[6]; \
	buf.b[BYTE_64_7] = src[7]; \
	\
	e = (buf.l & IEEE64_EXP_MASK) >> IEEE64_EXP_SHIFT; \
	m = (buf.l & IEEE64_MAN_MASK); \
	s = (buf.l & IEEE64_SIGN_MASK); \
	\
	if (e > IEEE64_EXP_DENORMAL) \
	{ \
	    e += (CRAY64_BIAS - IEEE64_BIAS); \
	    buf.l = s | (e << 48) | (1L << 47) | (m >> 5); \
	} \
	else \
	{ \
	    if (m && ALLOW_DENORMALS) /* != 0.0 */ \
	    { \
		e = (CRAY64_BIAS - IEEE64_BIAS); \
		while ((m & 0x000ff80000000000) == 0) \
		{ \
		    m = m << 7; \
		    e -= 7; \
		} \
		while ((m & 0x0008000000000000) == 0) \
		{ \
		    m = m << 1; \
		    e -= 1; \
		} \
		buf.l = s | (e << 48) | (m >> 4); \
	    } \
	    else \
	    { \
		buf.l = s; \
	    } \
	} \
	\
	dst[0] = buf.b[0]; \
	dst[1] = buf.b[1]; \
	dst[2] = buf.b[2]; \
	dst[3] = buf.b[3]; \
	dst[4] = buf.b[4]; \
	dst[5] = buf.b[5]; \
	dst[6] = buf.b[6]; \
	dst[7] = buf.b[7]; \
	\
	src += 8; \
	dst += 8; \
    } \
    *buffer += count * 8; \
}

#define GET_IEEE64BE_TO_CRAY64() \
{ \
    unsigned long	s, e, m; \
    \
    union \
    { \
	unsigned long	l; \
	nexus_byte_t	b[8]; \
    } buf; \
    \
    for (i = 0; i < count; i++) \
    { \
	buf.b[BYTE_64_7] = src[0]; \
	buf.b[BYTE_64_6] = src[1]; \
	buf.b[BYTE_64_5] = src[2]; \
	buf.b[BYTE_64_4] = src[3]; \
	buf.b[BYTE_64_3] = src[4]; \
	buf.b[BYTE_64_2] = src[5]; \
	buf.b[BYTE_64_1] = src[6]; \
	buf.b[BYTE_64_0] = src[7]; \
	\
	e = (buf.l & 0x7ff0000000000000) >> 52; \
	m = (buf.l & 0x000fffffffffffff); \
	s = (buf.l & 0x8000000000000000); \
	\
	if (e > 0) \
	{ \
	    e += (CRAY64_BIAS - IEEE64_BIAS); \
	    buf.l = s | (e << 48) | (1L << 47) | (m >> 5); \
	} \
	else \
	{ \
	    if (m && ALLOW_DENORMALS) /* != 0.0 */ \
	    { \
		e = (CRAY64_BIAS - IEEE64_BIAS); \
		while ((m & 0x000ff80000000000) == 0) \
		{ \
		    m = m << 7; \
		    e -= 7; \
		} \
		while ((m & 0x0008000000000000) == 0) \
		{ \
		    m = m << 1; \
		    e -= 1; \
		} \
		buf.l = s | (e << 48) | (m >> 4); \
	    } \
	    else \
	    { \
		buf.l = s; \
	    } \
	} \
	\
	dst[0] = buf.b[0]; \
	dst[1] = buf.b[1]; \
	dst[2] = buf.b[2]; \
	dst[3] = buf.b[3]; \
	dst[4] = buf.b[4]; \
	dst[5] = buf.b[5]; \
	dst[6] = buf.b[6]; \
	dst[7] = buf.b[7]; \
	\
	src += 8; \
	dst += 8; \
    } \
    *buffer += count * 8; \
}

#define GET_CRAY64BE_TO_IEEE32() \
{ \
    INT32_T		e; \
    unsigned INT32_T	m; \
    union \
    { \
       unsigned INT32_T	f; \
       char		b[4]; \
    } buf; \
    \
    for (i = 0; i < count; i++) \
    { \
	e = ((INT32_T)(src[0]) << 8) | (INT32_T)src[1]; \
        buf.f = (e & 0x8000) << 16;			/* sign bit */ \
	e = (e & 0x7fff) + IEEE32_BIAS - CRAY64_BIAS;	/* exp bits */ \
	m = ((unsigned INT32_T)(src[2]) << 16) | \
	    ((unsigned INT32_T)(src[3]) << 8) | \
	    ((unsigned INT32_T)(src[4])); \
	if (e > IEEE32_EXP_DENORMAL) \
	{ \
	  if (m) \
	      buf.f |= (((unsigned INT32_T)e << IEEE32_EXP_SHIFT) | \
			(m & IEEE32_MAN_MASK)); \
	} \
	else if (ALLOW_DENORMALS) \
	{ \
	    if (e > -IEEE32_EXP_SHIFT) \
	    { \
	        buf.f |= (m >> (1 - e)); \
	    } \
	} \
	dst[0] = buf.b[0]; \
	dst[1] = buf.b[1]; \
	dst[2] = buf.b[2]; \
	dst[3] = buf.b[3]; \
	src += 8; \
	dst += 4; \
    } \
    *buffer += count * 8; \
}

#define GET_CRAY64BE_TO_IEEE64_32() \
{ \
    INT32_T		e; \
    unsigned INT32_T	m_hi, m_lo; \
    union \
    { \
	unsigned INT32_T	d[2]; \
	nexus_byte_t		b[8]; \
    } buf; \
    \
    for (i = 0; i < count; i++) \
    { \
	buf.d[BYTE_16_0] = 0; \
	e = ((INT32_T)(src[0]) << 8) | (INT32_T)src[1]; \
	buf.d[BYTE_16_1] = ((unsigned INT32_T)e & 0x8000) << 16; \
	e = (e & 0x7fff) - (CRAY64_BIAS - IEEE64_BIAS); \
	m_hi = (((unsigned INT32_T)(src[2])) << 13) | \
	       (((unsigned INT32_T)(src[3])) << 5) | \
	       (unsigned INT32_T)(src[4] >> 3); \
	m_lo = (((unsigned INT32_T)(src[4])) << 29) | \
	       (((unsigned INT32_T)(src[5])) << 21) | \
	       (((unsigned INT32_T)(src[6])) << 13) | \
	       (((unsigned INT32_T)(src[7])) << 5); \
	if (e > IEEE64_EXP_DENORMAL) \
	{ \
	    if (m_lo || m_hi) \
	    { \
		buf.d[BYTE_16_1] |= (((unsigned INT32_T)e << 20) | \
				     (m_hi & IEEE64_MAN_MASK_HI)); \
		buf.d[BYTE_16_0] = m_lo; \
	    } \
	} \
	else if (ALLOW_DENORMALS) \
	{ \
	    m_hi |= (1L << (IEEE64_EXP_SHIFT - 32)); \
	    if (e > -IEEE64_EXP_SHIFT) \
	    { \
		e = 1 - e; \
		buf.d[BYTE_16_1] |= (m_hi >> e); \
		if (e < 32) \
		    m_lo = (m_lo >> e) | (m_hi << (32 - e)); \
		else \
		    m_lo = (m_hi >> (e - 32)); \
		buf.d[BYTE_16_0] = m_lo; \
	    } \
	} \
	\
	dst[0] = buf.b[0]; \
	dst[1] = buf.b[1]; \
	dst[2] = buf.b[2]; \
	dst[3] = buf.b[3]; \
	dst[4] = buf.b[4]; \
	dst[5] = buf.b[5]; \
	dst[6] = buf.b[6]; \
	dst[7] = buf.b[7]; \
	src += 8; \
	dst += 8; \
    } \
    *buffer += count * 8; \
}

#define GET_CRAY64BE_TO_IEEE64_64() \
{ \
    INT64_T		e; \
    unsigned INT64_T	m; \
    union \
    { \
       unsigned INT64_T	d; \
       nexus_byte_t	b[8]; \
    } buf; \
    \
    for (i = 0; i < count; i++) \
    { \
	e = (((INT64_T)(src[0])) << 8) | (INT64_T)src[1]; \
        buf.d = ((unsigned INT64_T)e & 0x8000L) << 48; \
	e = (e & 0x7fff) + (IEEE64_BIAS - CRAY64_BIAS); \
	m = (((unsigned INT64_T)(src[2])) << 45) | \
            (((unsigned INT64_T)(src[3])) << 37) | \
	    (((unsigned INT64_T)(src[4])) << 29) | \
	    (((unsigned INT64_T)(src[5])) << 21) | \
	    (((unsigned INT64_T)(src[6])) << 13) | \
	    (((unsigned INT64_T)(src[7])) << 5); \
	if (e > IEEE64_EXP_DENORMAL) \
	{ \
	  if (m) \
	      buf.d |= (((unsigned INT64_T)e << IEEE64_EXP_SHIFT) | \
			(m & IEEE64_MAN_MASK)); \
	} \
	else if (ALLOW_DENORMALS) \
	{ \
	    m &= (IEEE64_MAN_MASK | (1L << IEEE64_EXP_SHIFT)); \
	    if (e > -IEEE64_EXP_SHIFT) \
	    { \
	        buf.d |= (m >> (1 - e)); \
	    }
	} \
	dst[0] = buf.b[0]; \
	dst[1] = buf.b[1]; \
	dst[2] = buf.b[2]; \
	dst[3] = buf.b[3]; \
	dst[4] = buf.b[4]; \
	dst[5] = buf.b[5]; \
	dst[6] = buf.b[6]; \
	dst[7] = buf.b[7]; \
	src += 8; \
	dst += 8; \
    } \
    *buffer += count * 8; \
}
